'' Test Routine for Pixel Serial Client
'' Send a bunch of sample data to by displayed on TX

CON
  ' Set up the processor clock in the standard way for 80MHz on DemoBoard
  _CLKMODE = xtal1 + pll16x
  _XINFREQ = 5_000_000 + 0000

 TX = 0 'Pin Sending Data

VAR
  long          i, j, k, l, m     'misc working vars
  
OBJ
  serial : "FullDuplexSerial"            'Standard serial driver

PUB Main | x ,c, o, d, p

    serial.start(-1, TX, 0, 115200)
      
    repeat k from 10 to 30 'coupla lines to show vertical resolution
      plot(k,k+8, 5)
      plot(k,k+12, 4)
      plot(k,k+16, 3)
      plot(k,k+20, 1)
      plot(k,k+22, 0)
       
    'Draw the ~400 color palette on screen, one dot at a time.  The standard saturation
    'propeller colors are arranged in 5x5 grids, with intensity running on one axis,
    'and color on another to form 25 element grids for each hue.  More effective hues
    'are possible.

    repeat j from 10 to 29  

        repeat k from 0 to 19 
           
           c := (k // 5) + 1
           repeat l from (j*8) to (j*8) + 7 step 2
             
             repeat m from (k*3) to (k*3)+ 2

    'Comment out one or the other of these lines, and uncomment a matching one to see
    'each palette without being added to the other.  This is also useful for seeing what
    'hues you should be watching for.
                                                                         
                     plot(l,m, (((29 - j) // 5 + 1) + ((j-10)/5)*8) +((k/5)*32) )  
                     'plot(l+1,m,(((29 - j) // 5 + 1) + ((j-10)/5)*8) +((k/5)*32))
                     
                     plot(l+1,m, c+(((j-10)/5)*8)+((k/5)*32))
                     'plot(l,m, c+(((j-10)/5)*8)+((k/5)*32))


     'Additional colors are possible using the high-saturation colors.  Not shown.

                    
    'plot standard prop color set these are mapped in the CLUT below.
    
    o := -1
    repeat k from 30 to 30+256 step 2
      o := o + 1
       repeat j from 70 to 95
         plot(k, j, o)
         plot(k+1, j, o)
         
pub plot(x,y,c)

      serial.tx(x)
      serial.tx(y)
      serial.tx(c) 
                   